unit tl_test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, TAPILine, StdCtrls, ExtCtrls;

type
  TformMain = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Modem1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Howtodial1: TMenuItem;
    Configuration1: TMenuItem;
    N1: TMenuItem;
    Connect1: TMenuItem;
    N2: TMenuItem;
    Disconnect1: TMenuItem;
    Memo1: TMemo;
    Panel1: TPanel;
    toWrite: TEdit;
    N3: TMenuItem;
    Sendfile1: TMenuItem;
    OpenDialog: TOpenDialog;
    Receivefile1: TMenuItem;
    SaveDialog1: TSaveDialog;
    TAPILine1: TTAPILine;
    procedure Exit1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Howtodial1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TAPILine1Connection(Sender: TObject);
    procedure Configuration1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure toWriteEnter(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure OnDissconectClick(Sender: TObject);
    procedure toWriteKeyPress(Sender: TObject; var Key: Char);
    procedure Sendfile1Click(Sender: TObject);
    procedure Receivefile1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TAPILine1DropCall(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMain: TformMain;
//  TAPILine1: TTAPILine;

implementation

uses Options, About;

{$R *.DFM}

procedure TformMain.Exit1Click(Sender: TObject);
begin
    Close;
end;

procedure TformMain.Options1Click(Sender: TObject);
begin
    if formOptions = nil Then
       formOptions := TformOptions.Create (self);
    formOptions.ShowModal;
    Connect1.Enabled := True;
    try
       TAPILine1.Open;
    except
        on Exception do ShowMessage ('Line isn''t properly configurated!');
    end;
end;

procedure TformMain.Howtodial1Click(Sender: TObject);
begin
    TAPILine1.TranslateDialog;
end;

procedure TformMain.FormCreate(Sender: TObject);
begin
    TAPILine1.InfoLabel := StatusBar1.Panels[0];
    Options1Click (nil);
end;

procedure TformMain.TAPILine1Connection(Sender: TObject);
begin
    ShowMessage ('Connected!');

    Disconnect1.Enabled := True;
    Connect1.Enabled := False;
    Sendfile1.Enabled := True;
    Receivefile1.Enabled := True;
end;

procedure TformMain.Configuration1Click(Sender: TObject);
begin
    TAPILine1.ConfigDialog;
end;

procedure TformMain.Connect1Click(Sender: TObject);
begin
    TAPILine1.MakeCall;
end;

procedure TformMain.Disconnect1Click(Sender: TObject);
begin
    TAPILine1.Drop;

    Disconnect1.Enabled := False;
    Connect1.Enabled := True;
    Sendfile1.Enabled := False;
    Receivefile1.Enabled := False;
end;

procedure TformMain.toWriteEnter(Sender: TObject);
begin
    TAPILine1.Write (toWrite.Text);
    toWrite.Text := '';
end;

procedure TformMain.Memo1DblClick(Sender: TObject);
begin
    Memo1.Lines.Add (TAPILine1.Read (0));
end;

procedure TformMain.OnDissconectClick(Sender: TObject);
begin
    Disconnect1.Enabled := False;
    Connect1.Enabled := True;
end;

procedure TformMain.toWriteKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = Chr (13) then
       Begin
       toWriteEnter (nil);
       key := Chr(0);
       End;

end;

procedure TformMain.Sendfile1Click(Sender: TObject);
Var
  F: file of byte;
  S: string;
  Buf: array[1..2048] of Char;
//  buf2 :PChar;
  NumRead, size: longint;
  timeToWrite, beforeWriting, afterWriting : DWORD;
  str: string;
begin
    if OpenDialog.Execute then          { Display Open dialog box }
       begin
{       try
       getmem (Buf, 2048);
       except
             on EOutOfMemory do ShowMessage ('Out of memory!');
       end;}
       AssignFile(F, OpenDialog.FileName);   { File selected in dialog box }
       Reset(F);
       size := FileSize(F);
       timeToWrite := 0;
       try
       SetLength (str, 2050);
       except
            on EOutOfMemory do ShowMessage ('Out of memory!')
       end;
//       if size < 2048 then
       repeat
            BlockRead (F, Buf, 2048, NumRead);
  //          buf2 := @buf;
            buf[NumRead] := Chr (0);
            if NumRead <> 0 then
               Begin
               str := StrPas (@Buf);
               TAPILine1.Write (str);
               End;
       until (NumRead = 0);

       TAPILine1.Write ('+ira++ira++ira++ira+');

       CloseFile (F);
       StatusBar1.Panels[0].text := 'Bytes has been write: '+IntToStr (size);
//       freemem (Buf);
       End;
end;

procedure TformMain.Receivefile1Click(Sender: TObject);
Var
  Buf: array[1..2048] of Char;
  F: file of byte;
  timeToWrite, beforeWriting, afterWriting : DWORD;
  size: longint;
begin
    if SaveDialog1.Execute then          { Display Open dialog box }
       begin
       AssignFile (F, SaveDialog1.FileName);   { File selected in dialog box }
       Rewrite(F);
       timeToWrite := 0;
       size := 0;
       While True do
           Begin
           beforeWriting := GetTickCount;
           TAPILine1.ReadLargeData (@buf, 10);
           if StrPos (@buf, '+ira+')<> nil Then break;
           afterWriting := GetTickCount;
           Inc (timeToWrite, afterWriting-beforeWriting);
           Inc (size, 10);
           BlockWrite (F, Buf, 10);
           Application.ProcessMessages;
           StatusBar1.Panels[0].text := 'Bytes has been read: '+IntToStr (size)+ '  Time elapsed: '+IntToStr (timeToWrite)+' ml.sec.';
           End;
       size := FileSize(F);
       CloseFile (F);
       StatusBar1.Panels[0].text := 'Bytes has been read: '+IntToStr (size)+ '  Time elapsed: '+IntToStr (timeToWrite)+' ml.sec.';
       end;
end;

procedure TformMain.FormDestroy(Sender: TObject);
begin
    TAPILine1.free;
end;

procedure TformMain.TAPILine1DropCall(Sender: TObject);
begin
    TAPILine1.Close;
    TAPILine1.Open;
end;

procedure TformMain.About1Click(Sender: TObject);
begin
    AboutBox := TAboutBox.Create (self);
    AboutBox.ShowModal;
    AboutBox.Free;
end;

end.
